function skewbScramble(seq, minLen)
{
	var i, j, k, len;
	var type = randomType();
	var symbol = new Array();
	var face = new Array(0, 1, 2, 3, 4, 5);
	var vertex = new Array(
		new Array(0, 0),
		new Array(1, 0),
		new Array(2, 0),
		new Array(3, 0),
		new Array(4, 0),
		new Array(5, 0),
		new Array(6, 0),
		new Array(7, 0)
	);

	while((solLen.charCodeAt(type) - 0x30) < minLen){
		type = randomType();
	}

	reconstruct(face, vertex, type);
	len = 0;
	for(i=solLen.charCodeAt(type); i>0x30; i--){
		for(j=0; j<8; j++){
			if(solLen.charCodeAt(turnConversion(j, face, vertex)) < i){
				turn(j, face, vertex);
				symbol[len] = j;
				len++;
				break;
			}
		}
	}
	k = 0;
	for(i=0; i<len; i++){
		if(symbol[len-i-1] < 6) {
			seq[2*i] = (Math.floor(symbol[len-i-1] / 2) + k) % 3;
		}else{
			seq[2*i] = 3;
			k = (k - symbol[len-i-1] + 8) % 3;
		}
		seq[(2*i)+1] = (symbol[len-i-1]) % 2;
	}

	return(len);
}

function randomType()
{
	var type = 0;

	for (i=6; i>=3; i--) {
		type = type * i + Math.floor(Math.random() * (i * 10)) % i;
	}
	type = type * 3 + Math.floor(Math.random() * 30) % 3;
	type = type * 4 + Math.floor(Math.random() * 30) % 3;
	type = type * 3 + Math.floor(Math.random() * 30) % 3;
	for (i=0; i<5; i++) {
		type = type * 3 + Math.floor(Math.random() * 30) % 3;
	}
	return( type );
}

function conversion(face, vertex)
{
	var i, j, sum;
	var type = 0;
	for (i=0; i<4; i++) {
		sum = 0;
		for (j=0; j<i; j++) 
			if (face[i] > face[j]) sum++;
		type = (type * (6 - i)) + (face[i] - sum);
	}

	type = (type * 3) + (vertex[1][0] - 1);
	type = (type * 4) + (vertex[4][0] - 4);
	type = (type * 3) + vertex[5][0] - ((vertex[4][0] < vertex[5][0])? 5:4);

	for (i=2; i< 7; i++) {
		type = (type * 3) + vertex[i][1];
	}

	return type;
}

function reconstruct(face, vertex, type)
{
	var i, j;

	for (i=6; i>=2; i--) {
		vertex[i][1] = type % 3;
		type = Math.floor(type / 3);
	}

	j = type % 3;
	vertex[5][0] = type % 3 + 4;
	type = Math.floor(type / 3);
	vertex[4][0] = type % 4 + 4;
	if (type & 1) {
		vertex[6][0] = (vertex[5][0] + 1) % 3 + 4;
		vertex[7][0] = vertex[5][0] % 3 + 4;
	} else {
		vertex[6][0] = vertex[5][0] % 3 +  4;
		vertex[7][0] = (vertex[5][0] + 1) % 3 + 4;
	}
	if(vertex[5][0] >= vertex[4][0]) vertex[5][0]++;
	if(vertex[6][0] >= vertex[4][0]) vertex[6][0]++;
	if(vertex[7][0] >= vertex[4][0]) vertex[7][0]++;
	type = Math.floor(type / 4);
	vertex[0][0] = 0;
	vertex[1][0] = type % 3 + 1;
	vertex[2][0] = (type+1) % 3 + 1;
	vertex[3][0] = (type+2) % 3 + 1;
	type = Math.floor(type / 3);

	vertex[0][1] = 0;
	vertex[1][1] = (9 - vertex[2][1] - vertex[3][1] + ((vertex[4][0] - 1) % 4) + ((vertex[4][0] % 2 == 0)? 1: -1) * j) % 3;
	vertex[7][1] = (13 - vertex[4][1] - vertex[5][1]- vertex[6][1] - vertex[1][0]) % 3;

	if ((((type & 1)+(Math.floor(type / 12)) & 1) & 1)) {
		face[4] = 1;
		face[5] = 0;
	} else {
		face[4] = 0;
		face[5] = 1;
	}
	for (i=3; i>=0; i--) {
		face[i] = (type) % (6 - i);
		type = Math.floor(type / (6 - i));
		for (j=i+1; j<6; j++) {
			if (face[j] >= face[i]) face[j]++;
		}
	}
}

function SWAP(ary, idx)
{
	var t
	t			   = ary[2][idx[2]];
	ary[2][idx[2]] = ary[1][idx[1]];
	ary[1][idx[1]] = ary[0][idx[0]];
	ary[0][idx[0]] = t; 
}
function TURN(a, x){
	a = (a + x) % 3;
}
function TURN_3(ary, idx, x)
{
	var t
	t			   = (ary[2][idx[2]] + x) % 3;
	ary[2][idx[2]] = (ary[1][idx[1]] + x) % 3;
	ary[1][idx[1]] = (ary[0][idx[0]] + x) % 3;
	ary[0][idx[0]] = t;
}

function turn(symbol, face, vertex)
{

	switch (symbol) {
	 case 0: /* F */
		SWAP(new Array(face,face,face), new Array(5,1,2));
		vertex[2][1] = (vertex[2][1] + 1) % 3;
		SWAP(new Array(vertex[4], vertex[7], vertex[5]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[7], vertex[5]), new Array(1,1,1), 2);
		break;
	 case 1: /* F' */
		SWAP(new Array(face,face,face), new Array(5,2,1));
		vertex[2][1] = (vertex[2][1] + 2) % 3;
		SWAP(new Array(vertex[4], vertex[5], vertex[7]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[5], vertex[7]), new Array(1,1,1), 1);
		break;
	 case 2: /* r */
		SWAP(new Array(face,face,face), new Array(0,1,4));
		vertex[1][1] = (vertex[1][1] + 1) % 3;
		SWAP(new Array(vertex[4], vertex[6], vertex[7]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[6], vertex[7]), new Array(1,1,1), 2);
		break;
	 case 3: /* r' */
		SWAP(new Array(face,face,face), new Array(0,4,1));
		vertex[1][1] = (vertex[1][1] + 2) % 3;
		SWAP(new Array(vertex[4], vertex[7], vertex[6]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[7], vertex[6]), new Array(1,1,1), 1);
		break;
	 case 4: /* B */
		SWAP(new Array(face,face,face), new Array(5,3,4));
		vertex[3][1] = (vertex[3][1] + 1) % 3;
		SWAP(new Array(vertex[4], vertex[5], vertex[6]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[5], vertex[6]), new Array(1,1,1), 2);
		break;
	 case 5: /* B' */
		SWAP(new Array(face,face,face), new Array(5,4,3));
		vertex[3][1] = (vertex[3][1] + 2) % 3;
		SWAP(new Array(vertex[4], vertex[6], vertex[5]), new Array(0,0,0));
		TURN_3(new Array(vertex[4], vertex[6], vertex[5]), new Array(1,1,1), 1);
		break;
	 case 6: /* R */
		SWAP(new Array(face,face,face), new Array(5,4,1));
		vertex[4][1] = (vertex[4][1] + 1) % 3;
		SWAP(new Array(vertex[1], vertex[2], vertex[3]), new Array(0,0,0));
		TURN_3(new Array(vertex[1], vertex[2], vertex[3]), new Array(1,1,1), 2);
		break;
	 case 7: /* R' */
		SWAP(new Array(face,face,face), new Array(5,1,4));
		vertex[4][1] = (vertex[4][1] + 2) % 3;
		SWAP(new Array(vertex[1], vertex[3], vertex[2]), new Array(0,0,0));
		TURN_3(new Array(vertex[1], vertex[3], vertex[2]), new Array(1,1,1), 1);
		break;
	 default:
		break;
	}
}

function turnConversion(symbol, face, vertex)
{
	var retVal;
	turn(symbol, face, vertex);
	retVal = conversion(face, vertex);
	turn(symbol + ((symbol % 2 == 0)? 1: -1), face, vertex);
	return retVal;
}
